﻿
function saveOptions(e) {

	e.preventDefault();

	try
	{
	
		let tab = JSON.parse(document.querySelector("#tab").value);
		let gn = document.querySelector("#gn").checked;
		let pgn = document.querySelector("#pgn").checked;
		let log = document.querySelector("#log").checked;
		
		let o = Object.create(null);

		o.gn = gn;
		o.pgn = pgn;
		o.tab = tab;
		o.log = log;
	
		let storing = browser.storage.local.set({settings: JSON.stringify(o)});
		
		storing.then((response)=>{

			browser.runtime.sendMessage({
			  from:    'options',
			  subject: 'settings',
			  settings: JSON.stringify(o)
			});

		}, (error)=>{
		
			document.querySelector("#msg").innerHTML = "Msg:Invalid data";
		});
		
		
	}
	catch(e)
	{

		console.log(e.message);
		document.querySelector("#msg").innerHTML = "Msg:Invalid data";
		
	}
	
}



function restoreOptions()
{

	let getting = browser.storage.local.get("settings");

	getting.then((result)=>{
	
	
	
		try
		{

			let o = JSON.parse(result.settings);
			document.querySelector("#gn").checked = o.gn;
			document.querySelector("#pgn").checked = o.pgn;
			document.querySelector("#log").checked = o.log;
			document.querySelector("#tab").innerHTML = JSON.stringify(o.tab);
		
		}
		catch(e)
		{
			console.log(e.message);			
			
		}
	
		
	
	}, (error)=>{
		
		console.log(`Error: ${error}`);
			
	});


}



document.addEventListener("DOMContentLoaded", restoreOptions);

document.querySelector("form").addEventListener("submit", saveOptions);

document.addEventListener('DOMContentLoaded', function() {

	let btn = document.getElementById('template');

	btn.addEventListener('click', function() {
		document.querySelector("#tab").value = String.raw`{"none":"All","en":"English","de":"German","fr":"French","es":"Spanish","pt":"Portuguese","it":"Italian","nl":"Dutch","pl":"Polish","no":"Norwegian","da":"Danish","sv":"Swedish","cs":"Czech","ru":"Russian"}`;
	});

});


browser.runtime.onMessage.addListener(function (msg, sender){
		
	if ((msg.from === 'background') && (msg.subject === 'info'))
	{
		document.querySelector("#msg").innerHTML = "Msg:";

		setTimeout(()=>{
			document.querySelector("#msg").innerHTML = "Msg:" + msg.text;	
		}, 800);
		
	
	}
});
